Unit Algebra;

Interface

Procedure Fraction(X,Eps:extended; Var Numerator,Denomerator:longint);
{ ।⠢ . ᫠   ஡ }
Function SqrSum(N:longint; Var I1,I2:longint):boolean;
{ ।⠢, ᫨  , ᫠   㬬 ⮢ }
Procedure CancelOut(Var I,J:longint);
{ ᮪饭 ஡ I/J }

Procedure RandInit1;
{ Seeds rand from the DOS clock }
Function Rand1:integer;
{ returns a 16 bit semi-poor quality pseudo-random number in AX }

Implementation

Procedure Fraction(X,Eps:extended; Var Numerator,Denomerator:longint);
Var p,q,p0,p1,q0,q1,ak:longint; B:boolean; l,k1:extended;
Begin
 p0:=1;
 p1:=Trunc(X);
 q0:=0; q1:=1;
 l:=Frac(X);
 B:=False;

 Repeat
  k1:=1/l;
  l:=Frac(k1);
  ak:=Trunc(k1);
  p:=ak*p1+p0;
  q:=ak*q1+q0;

  If Abs(p/q-X)>Eps then begin
   p0:=p1; p1:=p;
   q0:=q1; q1:=q
  end
  else B:=True
 until B;
 Numerator:=p;
 Denomerator:=q
End;

Function SqrSum(N:longint; Var I1,I2:longint):boolean;
Begin
 SqrSum:=True;
 I1:=1;
 While 2*I1*I1<=N do begin
  I2:=Round(Sqrt(N-I1*I1));
  If I1*I1+I2*I2=N then exit;
  Inc(I1)
 end;
 SqrSum:=False
End;

Procedure CancelOut(Var I,J:longint);
Var N,K:longint;
Begin
 N:=1;
 While N<=I do begin
  K:=N*I div J;
  If K*J=N*I then begin
   I:=K; J:=N;
   break;
  end;
  Inc(N)
 end;
End;

Var Seed1:word;

Procedure RandInit1;assembler; { Seeds rand from the DOS clock }
asm
 mov ah,2ch
 int 21h
 mov Seed1,dx
end;

Function Rand1:integer;assembler;
{ returns a 16 bit semi-poor quality pseudo-random number in AX }
Const
 k1=9821; k2=1;
asm
 mov ax,Seed1
 mov bx,k1
 imul bx
 add ax,k2
 mov Seed1,ax
 ror al,1
 rol ah,1
end;

End.