Unit Longs64;

Interface

Type
 Long64=record
  L0,L1:longint
 end;

Procedure Inc64(Var Z:Long64; X:Long64);
Procedure Dec64(Var Z:Long64; X:Long64);
Procedure Add64(Var Z:Long64; X,Y:Long64);
Procedure Sub64(Var Z:Long64; X,Y:Long64);
Procedure Mult64(Var Z:Long64; X,Y:Long64);
Procedure Div64(Var Z:Long64; X,Y:Long64);
Procedure MultTo64(X,Y:longint; Var Z:Long64);

Procedure IntTo64(W:integer; Var L:long64);
Procedure WordTo64(W:word; Var L:long64);
Procedure LongTo64(W:longint; Var L:long64);

Implementation

Procedure Inc64(Var Z:Long64; X:Long64);assembler;
{ z=z+x }
asm
 les di,X
 db 26h,66h,8bh,05h     { mov eax,es:[di] }
 db 26h,66h,8bh,55h,04h { mov edx,es:[di+4] }
 les di,Z
 db 26h,66h,01h,05h     { add es:[di],eax }
 db 26h,66h,11h,55h,04h { adc es:[di+4],edx }
end;

Procedure Dec64(Var Z:Long64; X:Long64);assembler;
{ z=z-x }
asm
 les di,X
 db 26h,66h,8bh,05h     { mov eax,es:[di] }
 db 26h,66h,8bh,55h,04h { mov edx,es:[di+4] }
 les di,Z
 db 26h,66h,29h,05h     { sub es:[di],eax }
 db 26h,66h,19h,55h,04h { sbb es:[di+4],edx }
end;

Procedure Add64(Var Z:Long64; X,Y:Long64);assembler;
{ z=x+y }
asm
 les di,X
 db 26h,66h,8bh,05h     { mov eax,es:[di] }
 db 26h,66h,8bh,55h,04h { mov edx,es:[di+4] }
 les di,Y
 db 26h,66h,01h,05h     { add es:[di],eax }
 db 26h,66h,11h,55h,04h { adc es:[di+4],edx }
 les di,Z
 db 26h,66h,89h,05h     { mov es:[di],eax }
 db 26h,66h,89h,55h,04h { mov es:[di+4],edx }
end;

Procedure Sub64(Var Z:Long64; X,Y:Long64);assembler;
{ z=x-y }
asm
 les di,X
 db 26h,66h,8bh,05h     { mov eax,es:[di] }
 db 26h,66h,8bh,55h,04h { mov edx,es:[di+4] }
 les di,Y
 db 26h,66h,29h,05h     { sub es:[di],eax }
 db 26h,66h,19h,55h,04h { sbb es:[di+4],edx }
 les di,Z
 db 26h,66h,89h,05h     { mov es:[di],eax }
 db 26h,66h,89h,55h,04h { mov es:[di+4],edx }
end;

Procedure Mult64(Var Z:Long64; X,Y:Long64);assembler;
{ z=x*y }
asm
 push ds
 les di,X
 db 26h,66h,8bh,05h     { mov eax,es:[di] }
 db 66h,8bh,0d8h        { mov ebx,eax }
 lds si,Y
 db 3eh,66h,8bh,4ch,04h { mov ecx,ds:[si+4] }
 db 66h,0f7h,0e1h       { mul ecx }
 db 66h,93h             { xchg eax,ebx }
 db 3eh,66h,8bh,0ch     { mov ecx,ds:[si] }
 db 66h,0f7h,0e1h       { mul ecx }
 db 66h,03h,0dah        { add ebx,edx }
 db 66h,91h             { xchg eax,ecx }
 db 26h,66h,8bh,75h,04h { mov esi,es:[di+4] }
 db 66h,0f7h,0e6h       { mul esi }
 db 66h,03h,0c3h        { add eax,ebx }
 les di,Z
 db 26h,66h,89h,0dh     { mov es:[di],ecx }
 db 26h,66h,89h,45h,04h { mov es:[di+4],eax }
 pop ds
end;

Procedure MultTo64(X,Y:longint; Var Z:Long64);assembler;
{ Z=X*Y }
asm
 db 66h,8bh,46h,0eh     { mov eax,[bp+0eh] }
 db 66h,8bh,4eh,0ah     { mov ecx,[bp+0ah] }
 db 66h,0f7h,0e9h       { imul ecx }
 les di,Z
 db 26h,66h,89h,05h     { mov es:[di],eax }
 db 26h,66h,89h,55h,04h { mov es:[di+4],edx }
end;

Procedure Div64(Var Z:Long64; X,Y:Long64);assembler;
{ z=x/y }
asm
 push ds
 lds si,X
 db 3eh,66h,8bh,04h     { mov eax,ds:[si] }
 db 3eh,66h,8bh,54h,04h { mov edx,ds:[si+4] }
 db 66h,33h,0ffh        { xor edi,edi }
 db 66h,0bh,0d2h        { or edx,edx }
 jns @div1
 db 66h,47h             { inc edi }
 db 66h,0f7h,0d8h       { neg eax }
 db 66h,83h,0d2h,00h    { adc edx,0 }
 db 66h,0f7h,0dah       { neg edx }
 db 3eh,66h,89h,04h     { mov ds:[si],eax }
 db 3eh,66h,89h,54h,04h { mov ds:[si+4],edx }
@div1:
 lds si,Y
 db 3eh,66h,8bh,1ch     { mov ebx,ds:[si] }
 db 3eh,66h,8bh,74h,04h { mov esi,ds:[si+4] }
 db 66h,0bh,0f6h        { or esi,esi }
 jns @div2
 db 66h,47h             { inc edi }
 db 66h,0f7h,0dbh       { neg ebx }
 db 66h,83h,0d6h,00h    { adc esi,0 }
 db 66h,0f7h,0deh       { neg esi }
@div2:
 jnz @div3 { Y>=2^16? }
{ Y<2^16 }
 db 66h,0bh,0dbh        { or ebx,ebx }
 jz @div9  { divede by zero? }
 db 66h,8bh,0c8h        { mov ecx,eax }
 db 66h,8bh,0c2h        { mov eax,edx }
 db 66h,33h,0d2h        { xor edx,edx }
 db 66h,0f7h,0f3h       { div ebx }
 db 66h,91h             { xchg eax,ecx }
 db 66h,0f7h,0f3h       { div ebx }
 jmp @div6

@div9: { divide error }
 db 66h,33h,0c0h        { xor eax,eax }
 db 66h,48h             { dec eax }
 db 66h,0b9h,0ffh,0ffh,0ffh,07fh { mov ecx,h } { return 7fffffffffffffff }
 jmp @div6

{ Y>=2^16 }
@div3:
 db 66h,0fh,0bdh,0ceh   { bsr ecx,esi } { shift right X and Y so that Y<2^16 }
 inc cl
 db 66h,53h             { push ebx }
 db 66h,0fh,0adh,0f3h   { shrd ebx,esi,cl }
 db 66h,0fh,0adh,0d0h   { shrd eax,edx,cl }
 db 66h,0d3h,0eah       { shr edx,cl }
 db 66h,0f7h,0f3h       { div ebx }  { estimate Z }
 db 66h,8bh,0d8h        { mov ebx,eax } { Z*Y }
 db 66h,0f7h,0e6h       { mul esi }
 db 66h,8bh,0c8h        { mov ecx,eax }
 db 66h,58h             { pop eax }
 db 66h,0f7h,0e3h       { mul ebx }
 db 66h,03h,0d1h        { add edx,ecx }
 jc @div4   { compare Z*Y with X }
 lds si,X
 db 3eh,66h,3bh,54h,04h { cmp edx,ds:[si+4] }
 ja @div4
 jb @div5
 db 3eh,66h,3bh,04h { cmp eax,ds:[si] }
 jbe @div5
@div4:
 db 66h,4bh             { dec ebx } { decrement Z if X*Y>X }
@div5:
 db 66h,33h,0c9h        { xor ecx,ecx }
 db 66h,8bh,0c3h        { mov eax,ebx }
@div6:
 db 66h,4fh             { dec edi }
 jnz @div7
 db 66h,0f7h,0d8h       { neg eax } { change sign of result }
 db 66h,83h,0d1h,00h    { adc ecx,0 }
 db 66h,0f7h,0d9h       { neg ecx }
@div7:
 les di,Z
 db 26h,66h,89h,05h     { mov es:[di],eax }
 db 26h,66h,89h,4dh,04h { mov es:[di+4],ecx }
 pop ds
end;

Procedure IntTo64(W:integer; Var L:long64);assembler;
asm
 mov ax,W
 db 66h,98h { cwde :ax->eax }
 db 66h,99h { cdq  :eax->edx:eax }
 les di,L
 db 26h,66h,89h,05h { mov es:[di],eax }
 db 26h,66h,89h,55h,04h { mov es:[di+4],edx }
end;

Procedure WordTo64(W:word; Var L:long64);assembler;
asm
 les di,L
 db 66h,33h,0c0h { xor eax,eax }
 db 26h,66h,89h,45h,04h { mov es:[di+4],eax }
 mov ax,W
 db 26h,66h,89h,05h { mov es:[di],eax }
end;

Procedure LongTo64(W:longint; Var L:long64);assembler;
asm
 db 66h,8bh,46h,0ah { mov eax,[bp+0ah] }
 db 66h,99h { cdq }
 les di,L
 db 26h,66h,89h,05h { mov es:[di],eax }
 db 26h,66h,89h,55h,04h { mov es:[di+4],edx }
end;

End.