{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit ALExpr;
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses Calcer,Def2x2,ExprComp,TPInline,Diffy;

Type

 {  ./ப ࠦ }
 PArithExpr=^TArithExpr;
 TArithExpr=object(TExprCompilator) 
  Expr:TExpression;
  ExprCalcer:PCalcer;
  IsArith:boolean;
  constructor Init(Data:string);
  procedure GetDataString(Var S:string);virtual;
  procedure Translate;virtual;
  function Calculate:PFloat;virtual;
  procedure Compile;
  destructor Done; virtual;
 end;

 {  ᪨ ࠦ }
 PLogicExpr=^TLogicExpr;
 TLogicExpr=object(TArithExpr)
  LTree:PLogicTree;
  procedure Translate;virtual;
  function CalculateB:boolean;virtual;
  procedure Compile;
 end;

Implementation

Constructor TArithExpr.Init(Data:string);
Begin
 Inherited Init;
 DataStr:=Data
End;

Procedure TArithExpr.GetDataString(Var S:string);
Begin
 If CurY<2 then S:=DataStr else EOFData:=True
End;

Procedure TArithExpr.Translate;
Begin
 SetJump(JumpPoint);
 If TransError=0 then begin
  GetTerm;
  IsArith:=True;
  Case TopTerm^.TermType of
   opStrArrVar,opStringConst..opStringPar,opStringFunc,opDirectStrFunc:begin
    TranslateString(Expr);
    IsArith:=False
   end;
   else TranslateMath(Expr,True);
  end;
  With TopTerm^ do
   If TermType<>opEndData then ErrorJump(0,X,Y,teEIE);
  Compile;
 end
 else begin
  If TransError=teEndExpected then TransError:=teEIE;
 end;
 DisposeMemTmp(0);
End;

Procedure TArithExpr.Compile;
Begin
 CompError.Error:=0;
 InWhile:=0;
 Mask8087(False);
 If IsArith then ExprCalcer:=New(PExpressionCalcer, Init(Expr))
 else ExprCalcer:=New(PStrExpressionCalcer, Init(Expr));
 Mask8087(True);
 If CompError.Error<>0 then begin
  TransError:=CompError.Error;
  ErrorX:=CompError.cX; ErrorY:=CompError.cY
 end
End;

Function TArithExpr.Calculate:PFloat;
Begin
 Mask8087(False);
 Calculate:=ExprCalcer^.Calculate;
 Mask8087(True)
End;

Destructor TArithExpr.Done;
Begin
 If ExprCalcer<>nil then Dispose(ExprCalcer, Done);
 Inherited Done;
End;


Procedure TLogicExpr.Translate;
Begin
 SetJump(JumpPoint);
 If TransError=0 then begin
  GetTerm;
  NLogCalcs:=0;
  LTree:=TranslateLogic(False,False);
  With TopTerm^ do
   If TermType<>opEndData then ErrorJump(0,X,Y,teEIE);
  Compile;
 end
 else begin
  If TransError=teEndExpected then TransError:=teEIE;
 end;
 DisposeMemTmp(0);
End;

Procedure TLogicExpr.Compile;
Begin
 CompError.Error:=0;
 InWhile:=0;
 Mask8087(False);
 ExprCalcer:=New(PLogicCalcer, Init(NLogCalcs,LTree));
 Mask8087(True);
 If CompError.Error<>0 then begin
  TransError:=CompError.Error;
  ErrorX:=CompError.cX; ErrorY:=CompError.cY
 end
End;

Function TLogicExpr.CalculateB:boolean;
Begin
 Mask8087(False);
 CalculateB:=PLogicCalcer(ExprCalcer)^.CalculateB;
 Mask8087(True)
End;

End.
