Unit MyValids;

Interface
Uses Objects,Validate;

Type

 { .  7/94 }
 PRealValidator=^TRealValidator;
 TRealValidator=object(TFilterValidator)
  Min,Max:extended;
  constructor Init(AMin,AMax:extended);
  procedure Error;virtual;
  function IsValid(Const S:string):boolean;virtual;
 end;

 { . ᫠ 饣  }
 PFloatValidator=^TFloatValidator;
 TFloatValidator=object(TRealValidator)
  constructor Init(AMin,AMax:extended);
  function Transfer(Var S:string; Buffer:pointer; Flag:TVTransfer):word;
   virtual;
 end;

 { . ᫠  䨪. 窮 }
 PFixedValidator=^TFixedValidator;
 TFixedValidator=object(TRealValidator)
  constructor Init(AMin,AMax:extended; ADecimals:byte);
  function Transfer(Var S:string; Buffer:pointer; Flag:TVTransfer):word;
   virtual;
 private
  Width,Decimals:byte;
 end;

 { ⭠ ⥫ ᫠ }
 PHexValidator=^THexValidator;
 THexValidator=object(TFilterValidator)
  Min,Max:longint;
  constructor Init(AMin,AMax:longint);
  function Transfer(Var S:string; Buffer:pointer; Flag:TVTransfer):word;
   virtual;
  procedure Error;virtual;
  function IsValid(Const S:string):boolean;virtual;
 end;

 {  ⥫ ᫠ }
 PBinValidator=^TBinValidator;
 TBinValidator=object(TFilterValidator)
  Min,Max:longint;
  constructor Init(AMin,AMax:longint);
  function Transfer(Var S:string; Buffer:pointer; Flag:TVTransfer):word;
   virtual;
  procedure Error;virtual;
  function IsValid(Const S:string):boolean;virtual;
 end;

 PNonBlankValidator=^TNonBlankValidator;
 TNonBlankValidator=object(TValidator)
  function IsValid(const S:string):boolean;virtual;
  procedure Error;virtual;
 end;

Implementation
Uses Msgbox,Mystring;

Constructor TRealValidator.Init(AMin,AMax:extended);
Begin
 Inherited Init(['0'..'9','-','.']);
 Options:=voTransfer;
 Min:=AMin; Max:=AMax
End;

Procedure TRealValidator.Error;
Var MaxStr,MinStr:string; Params:array[0..1] of longint;
Begin
 Str(Min,MinStr); Str(Max,MaxStr);
 Params[0]:=longint(@MinStr);
 Params[1]:=longint(@MaxStr);
 MessageBox(^C'ॡ ᫮  '^M^C+' %s  %s',
  @Params,mfError+mfOKButton)
End;

Function TRealValidator.IsValid(Const S:string):boolean;
Var V:extended; cod:integer;
Begin
 IsValid:=False;
 If Inherited IsValid(S) then begin
  Val(S,V,cod);
  If (cod=0) and (V>=Min) and (V<=Max) then IsValid:=True
 end
End;

Constructor TFloatValidator.Init(AMin,AMax:extended);
Begin
 Inherited Init(AMin,AMax);
 Include(ValidChars,'e');
 Include(ValidChars,'E')
End;

Function TFloatValidator.Transfer(Var S:string; Buffer:pointer;
  Flag:TVTransfer):word;
Var cod:integer; V:extended;
Begin
 If Options and voTransfer<>0 then begin
  Transfer:=SizeOf(V);
  Case Flag of
   vtGetData:begin
    Val(S,V,cod); extended(Buffer^):=V
   end;
   vtSetData: begin
    Str(extended(Buffer^),S);
    FastTrimHead(S)
   end;
  end
 end
 else Transfer:=0
End;

Constructor TFixedValidator.Init(AMin,AMax:extended; ADecimals:byte);
Begin
 Inherited Init(AMin,AMax);
 Decimals:=ADecimals;
 Width:=Decimals+2
End;

Function TFixedValidator.Transfer(Var S:string; Buffer:pointer;
 Flag:TVTransfer):word;
Var cod:integer; V:extended;
Begin
 If Options and voTransfer<>0 then begin
  Transfer:=SizeOf(V);
  Case Flag of
   vtGetData:begin
    Val(S,V,cod); extended(Buffer^):=V
   end;
   vtSetData:begin
    Str(extended(Buffer^):Width:Decimals,S);
    FastTrimHead(S)
   end
  end
 end
 else Transfer:=0
End;

Constructor THexValidator.Init(AMin,AMax:longint);
Begin
 Inherited Init(['0'..'9','-','A'..'F','a'..'f']);
 Options:=voTransfer;
 Min:=AMin; Max:=AMax
End;

Function THexValidator.Transfer(Var S:string; Buffer:pointer;
 Flag:TVTransfer):word;
Var V:longint; cod:byte;
Begin
 If Options and voTransfer<>0 then begin
  Transfer:=SizeOf(V);
  Case Flag of
   vtGetData:begin
    cod:=HexToLong(UpperCase(S),V);
    longint(Buffer^):=V
   end;
   vtSetData:begin
    S:=HexLong(V); Dec(S[0]);
   end
  end
 end
 else Transfer:=0
End;

Procedure THexValidator.Error;
Var MaxStr,MinStr:string; Params:array[0..1] of longint;
Begin
 MinStr:=HexLong(Min); MaxStr:=HexLong(Max);
 Params[0]:=longint(@MinStr);
 Params[1]:=longint(@MaxStr);
 MessageBox(^C'ॡ ᫮  '^M^C+' %s  %s',
  @Params,mfError+mfOKButton)
End;

Function THexValidator.IsValid(Const S:string):boolean;
Var V:longint; cod:byte;
Begin
 IsValid:=False;
 If Inherited IsValid(S) then begin
  cod:=HexToLong(UpperCase(S),V);
  If (cod=0) and (V>=Min) and (V<=Max) then IsValid:=True
 end
End;

Constructor TBinValidator.Init(AMin,AMax:longint);
Begin
 Inherited Init(['0'..'1']);
 Options:=voTransfer;
 Min:=AMin; Max:=AMax
End;

Function TBinValidator.Transfer(Var S:string; Buffer:pointer;
 Flag:TVTransfer):word;
Var V:longint; cod:byte;
Begin
 If Options and voTransfer<>0 then begin
  Transfer:=SizeOf(V);
  Case Flag of
   vtGetData:begin
    cod:=BinToLong(S,V);
    longint(Buffer^):=V
   end;
   vtSetData:begin
    S:=BinLong(V); Dec(S[0]);
   end
  end
 end
 else Transfer:=0
End;

Procedure TBinValidator.Error;
Var MaxStr,MinStr:string; Params:array[0..1] of longint;
Begin
 MinStr:=BinLong(Min); MaxStr:=BinLong(Max);
 Params[0]:=longint(@MinStr);
 Params[1]:=longint(@MaxStr);
 MessageBox(^C'ॡ ᫮  '^M^C+' %s  %s',
  @Params,mfError+mfOKButton)
End;

Function TBinValidator.IsValid(Const S:string):boolean;
Var V:longint; cod:byte;
Begin
 IsValid:=False;
 If Inherited IsValid(S) then begin
  cod:=BinToLong(S,V);
  If (cod=0) and (V>=Min) and (V<=Max) then IsValid:=True
 end
End;

Function TNonBlankValidator.IsValid(const S:string):boolean;
Var St:string;
Begin
 St:=S;
 TrimFilter(St);
 IsValid:=St<>''
End;

Procedure TNonBlankValidator.Error;
Begin
 MessageBox(^C' 祭!',nil,mfError+mfOKButton);
End;

End.